diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
index aa5eab8f5..c61d9f810 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
@@ -538,35 +460,27 @@ public class ScreenStats extends Screen {
         }
 
         @Override
-        protected void renderHeader(int x, int y, Tessellator tessellator)
-        {
+        protected void renderHeader(int x, int y, TessellatorGeneral tessellator) {
             super.renderHeader(x, y, tessellator);
-            if(clickedColumn == 0)
-            {
+            if (this.clickedColumn == 0) {
                 drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/stats/crafted"));
-            } else
-            {
+            } else {
                 drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/stats/crafted"));
             }
-            if(clickedColumn == 1)
-            {
+            if (this.clickedColumn == 1) {
                 drawGuiIcon(((x + COLUMN1_RIGHT) - STATS_ICON_SIZE) + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/stats/used"));
-            } else
-            {
+            } else {
                 drawGuiIcon(((x + COLUMN1_RIGHT) - STATS_ICON_SIZE), y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/stats/used"));
             }
-            if(clickedColumn == 2)
-            {
+            if (this.clickedColumn == 2) {
                 drawGuiIcon(((x + COLUMN2_RIGHT) - STATS_ICON_SIZE) + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/stats/mined"));
-            } else
-            {
+            } else {
                 drawGuiIcon(((x + COLUMN2_RIGHT) - STATS_ICON_SIZE), y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/screen/stats/mined"));
             }
         }
 
         @Override
-        protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
-        {
+        protected void renderItem(int index, int x, int y, int height, TessellatorGeneral tessellator) {
             StatItem statItem = getStat(index);
             int id = statItem.getItem().id;
             renderItemAsIcon(x + 40, y, id);
@@ -576,17 +490,13 @@ public class ScreenStats extends Screen {
         }
 
         @Override
-        protected String getTooltipKey(int column)
-        {
-            if(column == 0)
-            {
+        protected String getTooltipKey(int column) {
+            if (column == 0) {
                 return "stat.crafted";
             }
-            if(column == 1)
-            {
+            if (column == 1) {
                 return "stat.used";
-            } else
-            {
+            } else {
                 return "stat.mined";
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
index 3d30cc8d5..0aed5225e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
@@ -4,25 +4,21 @@ import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL41;
 
 import java.io.File;
 import java.util.ArrayList;
 import java.util.List;
 
-import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_HEIGHT;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_WIDTH;
-import static org.lwjgl.opengl.GL11.glGetTexLevelParameteri;
-
 public class ScreenTextureViewer extends Screen {
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
@@ -43,134 +39,132 @@ public class ScreenTextureViewer extends Screen {
     }
 
     @Override
-    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
-    {
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
         if (eventKey == Keyboard.KEY_LEFT) {
             cycleTexture(-1);
         } else if (eventKey == Keyboard.KEY_RIGHT) {
             cycleTexture(1);
         } else if (eventKey == Keyboard.KEY_ESCAPE) {
-            mc.displayScreen(parentScreen);
+            this.mc.displayScreen(this.parentScreen);
         }
-        List<ButtonElement> _buttons = new ArrayList<>(buttons);
-        for (ButtonElement button : _buttons){
-            if (button instanceof IListenerElement && button.isHovered(mx, my)){
+        List<ButtonElement> _buttons = new ArrayList<>(this.buttons);
+        for (ButtonElement button : _buttons) {
+            if (button instanceof IListenerElement && button.isHovered(mx, my)) {
                 ((IListenerElement<?>) button).onKeyTyped(eventCharacter, eventKey);
             }
         }
     }
+
     @Override
-    public void tick(){
-        List<ButtonElement> _buttons = new ArrayList<>(buttons);
-        for (ButtonElement button : _buttons){
-            if (button instanceof ListenerButtonElement){
+    public void tick() {
+        List<ButtonElement> _buttons = new ArrayList<>(this.buttons);
+        for (ButtonElement button : _buttons) {
+            if (button instanceof ListenerButtonElement) {
                 ((ListenerButtonElement) button).tick();
             }
         }
     }
-    public void init()
-    {
 
-        top = TOP_SPACING;
-        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
-        add(new ListenerButtonElement(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")).setActionListener(() -> {
+    public void init() {
+
+        this.top = TOP_SPACING;
+        this.bottom = this.height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+        add(new ListenerButtonElement(0, this.width / 2 - 100, this.height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")).setActionListener(() -> {
             removed();
-            mc.displayScreen(null);
+            this.mc.displayScreen(null);
         }));
 
-        leftTexCycle = add(new ListenerButtonElement(1, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "<")
+        this.leftTexCycle = add(new ListenerButtonElement(1, this.width - (20 + BUTTON_SPACING) * 2, this.bottom - (BUTTON_SPACING + 20), 20, 20, "<")
             .setActionListener(() -> cycleTexture(-1)));
-        add(new ListenerButtonElement(2, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20), 20, 20, ">")
+        add(new ListenerButtonElement(2, this.width - (20 + BUTTON_SPACING), this.bottom - (BUTTON_SPACING + 20), 20, 20, ">")
             .setActionListener(() -> cycleTexture(1)));
 
-        add(new ListenerButtonElement(11, BUTTON_SPACING, bottom - BUTTON_SPACING - 20, 20, 20, "V")
-            .setActionListener(() -> drawCheckers = !drawCheckers)
+        add(new ListenerButtonElement(11, BUTTON_SPACING, this.bottom - BUTTON_SPACING - 20, 20, 20, "V")
+            .setActionListener(() -> this.drawCheckers = !this.drawCheckers)
         );
-        add(new ListenerButtonElement(11, 20 + BUTTON_SPACING * 2, bottom - BUTTON_SPACING - 20, 20, 20, "F")
-            .setActionListener(() -> flip = !flip)
+        add(new ListenerButtonElement(11, 20 + BUTTON_SPACING * 2, this.bottom - BUTTON_SPACING - 20, 20, 20, "F")
+            .setActionListener(() -> this.flip = !this.flip)
         );
-        add(new ListenerButtonElement(12, 40 + BUTTON_SPACING * 3, bottom - BUTTON_SPACING - 20, 20, 20, "D")
+        add(new ListenerButtonElement(12, 40 + BUTTON_SPACING * 3, this.bottom - BUTTON_SPACING - 20, 20, 20, "D")
             .setActionListener(() -> {
                 Textures.dumpTextures();
                 FileOpener.open(new File("dumpTextures"));
             })
         );
-        add(new ListenerButtonElement(13, 60 + BUTTON_SPACING * 4, bottom - BUTTON_SPACING - 20, 20, 20, "T")
-            .setActionListener(() -> drawText = !drawText)
+        add(new ListenerButtonElement(13, 60 + BUTTON_SPACING * 4, this.bottom - BUTTON_SPACING - 20, 20, 20, "T")
+            .setActionListener(() -> this.drawText = !this.drawText)
         );
     }
 
-    protected void buttonClicked(@NotNull ButtonElement button)
-    {
+    protected void buttonClicked(@NotNull ButtonElement button) {
     }
 
-    protected void buttonReleased(@NotNull ButtonElement button)
-    {
+    protected void buttonReleased(@NotNull ButtonElement button) {
     }
 
     protected void cycleTexture(int offset) {
         IntList textureList = GLAllocation.textureNames;
-        texIndex += offset;
-        if (texIndex < 0) {
-            texIndex += textureList.size();
+        this.texIndex += offset;
+        if (this.texIndex < 0) {
+            this.texIndex += textureList.size();
         }
-        texIndex = texIndex % textureList.size();
+        this.texIndex = this.texIndex % textureList.size();
     }
 
     public void render(int mx, int my, float partialTick) {
         renderBackground();
 
-        drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
+        drawStringCenteredNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.texture_viewer.label.title"), this.width / 2, 5, 0xFFFFFF);
 
         IntList textureList = GLAllocation.textureNames;
-        int id = texIndex % textureList.size();
-        GL11.glBindTexture(GL_TEXTURE_2D, textureList.getInt(id));
-
-        Texture t = mc.textureManager.idToTextureMap.get(textureList.getInt(id));
+        int id = this.texIndex % textureList.size();
+        GL41.glBindTexture(GL41.GL_TEXTURE_2D, textureList.getInt(id));
 
+        Texture t = this.mc.textureManager.idToTextureMap.get(textureList.getInt(id));
 
-        GL11.glEnable(GL_BLEND);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.enableState(State.DEPTH_TEST);
 
-        int texWidth = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
-        int texHeight = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
+        int texWidth = GL41.glGetTexLevelParameteri(GL41.GL_TEXTURE_2D, 0, GL41.GL_TEXTURE_WIDTH);
+        int texHeight = GL41.glGetTexLevelParameteri(GL41.GL_TEXTURE_2D, 0, GL41.GL_TEXTURE_HEIGHT);
         double ratio = (double) texWidth / texHeight;
 
-        double imgHeight = (bottom - top - 40d);
+        double imgHeight = (this.bottom - this.top - 40d);
         double imgWidth = imgHeight * ratio;
 
-        if (imgWidth > width * 0.75) {
-            imgWidth = width * 0.75f;
-            imgHeight = imgWidth/ratio;
+        if (imgWidth > this.width * 0.75) {
+            imgWidth = this.width * 0.75f;
+            imgHeight = imgWidth / ratio;
         }
 
-        double x = (width - imgWidth)/2;
-        double y = (height - imgHeight)/2;
+        double x = (this.width - imgWidth) / 2;
+        double y = (this.height - imgHeight) / 2;
 
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
 
-        if (drawCheckers) {
-            mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/gui/designer_bg.png"));
+        if (this.drawCheckers) {
+            this.mc.textureManager.bindTexture(this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/designer_bg.png"));
             tessellator.startDrawingQuads();
-            tessellator.addVertexWithUV(x + 0,         y + imgHeight,   zLevel, 0,          imgHeight/2);
-            tessellator.addVertexWithUV(x + imgWidth,  y + imgHeight,   zLevel, imgWidth/2, imgHeight/2);
-            tessellator.addVertexWithUV(x + imgWidth,  y + 0,           zLevel, imgWidth/2, 0);
-            tessellator.addVertexWithUV(x + 0,         y + 0,           zLevel, 0,          0);
+            tessellator.addVertexWithUV(x + 0, y + imgHeight, this.zLevel, 0, imgHeight / 2);
+            tessellator.addVertexWithUV(x + imgWidth, y + imgHeight, this.zLevel, imgWidth / 2, imgHeight / 2);
+            tessellator.addVertexWithUV(x + imgWidth, y + 0, this.zLevel, imgWidth / 2, 0);
+            tessellator.addVertexWithUV(x + 0, y + 0, this.zLevel, 0, 0);
             tessellator.draw();
         }
 
-        GL11.glBindTexture(GL_TEXTURE_2D, textureList.getInt(id));
+        GL41.glBindTexture(GL41.GL_TEXTURE_2D, textureList.getInt(id));
         tessellator.startDrawingQuads();
-        if (flip) {
-            tessellator.addVertexWithUV(x + 0,          y + imgHeight,  zLevel, 0, 0);
-            tessellator.addVertexWithUV(x + imgWidth,   y + imgHeight,  zLevel, 1, 0);
-            tessellator.addVertexWithUV(x + imgWidth,   y + 0,          zLevel, 1, 1);
-            tessellator.addVertexWithUV(x + 0,          y + 0,          zLevel, 0, 1);
+        if (this.flip) {
+            tessellator.addVertexWithUV(x + 0, y + imgHeight, this.zLevel, 0, 0);
+            tessellator.addVertexWithUV(x + imgWidth, y + imgHeight, this.zLevel, 1, 0);
+            tessellator.addVertexWithUV(x + imgWidth, y + 0, this.zLevel, 1, 1);
+            tessellator.addVertexWithUV(x + 0, y + 0, this.zLevel, 0, 1);
         } else {
-            tessellator.addVertexWithUV(x + 0,          y + imgHeight,  zLevel, 0, 1);
-            tessellator.addVertexWithUV(x + imgWidth,   y + imgHeight,  zLevel, 1, 1);
-            tessellator.addVertexWithUV(x + imgWidth,   y + 0,          zLevel, 1, 0);
-            tessellator.addVertexWithUV(x + 0,          y + 0,          zLevel, 0, 0);
+            tessellator.addVertexWithUV(x + 0, y + imgHeight, this.zLevel, 0, 1);
+            tessellator.addVertexWithUV(x + imgWidth, y + imgHeight, this.zLevel, 1, 1);
+            tessellator.addVertexWithUV(x + imgWidth, y + 0, this.zLevel, 1, 0);
+            tessellator.addVertexWithUV(x + 0, y + 0, this.zLevel, 0, 0);
         }
 
         tessellator.draw();
@@ -185,12 +179,12 @@ public class ScreenTextureViewer extends Screen {
 
         super.render(mx, my, partialTick);
 
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
+        GLRenderer.disableState(State.DEPTH_TEST);
 
-        if (drawText) {
-            drawStringShadow(this.fontRenderer, "Tex ID: " + id , 1, top + 1, 0xFFFFFF);
-            drawStringShadow(this.fontRenderer, "Tex Width: " + texWidth, 1, top + 11, 0xFFFFFF);
-            drawStringShadow(this.fontRenderer, "Tex Height: " + texHeight, 1, top + 21, 0xFFFFFF);
+        if (this.drawText) {
+            drawStringShadow(this.fontRenderer, "Tex ID: " + id, 1, this.top + 1, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer, "Tex Width: " + texWidth, 1, this.top + 11, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer, "Tex Height: " + texHeight, 1, this.top + 21, 0xFFFFFF);
 
             String s;
             if (t == null) {
@@ -199,37 +193,36 @@ public class ScreenTextureViewer extends Screen {
                 s = t.toString();
             }
             String[] lines = s.split("\n");
-            int yOff = top + 31;
+            int yOff = this.top + 31;
             for (String line : lines) {
-                drawStringShadow(fontRenderer, line, 1, yOff, 0xFFFFFF);
+                drawStringShadow(this.fontRenderer, line, 1, yOff, 0xFFFFFF);
                 yOff += 10;
             }
         }
+        GLRenderer.popFrame();
     }
+
     @Override
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.currentWorld == null)
-        {
-            Tessellator tessellator = Tessellator.instance;
-            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        if (this.mc.currentWorld == null) {
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
-            tessellator.setColorOpaque_I(0x202020);
+            tessellator.setColorOpaque1i(0x202020);
 
-            tessellator.addVertexWithUV(0,      bottom, 0.0D,   0,              bottom / scale);
-            tessellator.addVertexWithUV(width,  bottom, 0.0D,   width / scale,  bottom / scale);
-            tessellator.addVertexWithUV(width,  top,    0.0D,   width / scale,  top / scale);
-            tessellator.addVertexWithUV(0,      top,    0.0D,   0,              top / scale);
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, this.bottom / scale);
+            tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, this.width / scale, this.bottom / scale);
+            tessellator.addVertexWithUV(this.width, this.top, 0.0D, this.width / scale, this.top / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, this.top / scale);
 
             tessellator.draw();
-        }
-        else
-        {
-            drawRect(0, 0, width, top, 0x5F000000);
-            drawRect(0, bottom, width, height, 0x5F000000);
+        } else {
+            drawRect(0, 0, this.width, this.top, 0x5F000000);
+            drawRect(0, this.bottom, this.width, this.height, 0x5F000000);
         }
     }
 }
